/*
 * FCKeditor - The text editor for Internet - http://www.fckeditor.net
 * Copyright (C) 2003-2007 Frederico Caldeira Knabben
 *
 * == BEGIN LICENSE ==
 *
 * Licensed under the terms of any of the following licenses at your
 * choice:
 *
 *  - GNU General Public License Version 2 or later (the "GPL")
 *    http://www.gnu.org/licenses/gpl.html
 *
 *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
 *    http://www.gnu.org/licenses/lgpl.html
 *
 *  - Mozilla Public License Version 1.1 or later (the "MPL")
 *    http://www.mozilla.org/MPL/MPL-1.1.html
 *
 * == END LICENSE ==
 *
 * This is the code behind of the uploader.aspx page used for Quick Uploads.
 */

using System ;
using System.Globalization ;
using System.Xml ;
using System.Web ;

namespace FredCK.FCKeditorV2
{
	public class Uploader : FileWorkerBase
	{
		protected override void OnLoad(EventArgs e)
		{
			// Get the posted file.
			HttpPostedFile oFile = Request.Files["NewFile"] ;

			// Check if the file has been correctly uploaded
			if ( oFile == null || oFile.ContentLength == 0 )
			{
				SendResults( 202 ) ;
				return ;
			}

			int iErrorNumber = 0 ;
			string sFileUrl = "" ;

			// Get the uploaded file name.
			string sFileName = System.IO.Path.GetFileName( oFile.FileName ) ;

			int iCounter = 0 ;

			while ( true )
			{
				string sFilePath = System.IO.Path.Combine( this.UserFilesDirectory, sFileName ) ;

				if ( System.IO.File.Exists( sFilePath ) )
				{
					iCounter++ ;
					sFileName = 
						System.IO.Path.GetFileNameWithoutExtension( oFile.FileName ) +
						"(" + iCounter + ")" +
						System.IO.Path.GetExtension( oFile.FileName ) ;

					iErrorNumber = 201 ;
				}
				else
				{
					oFile.SaveAs( sFilePath ) ;

					sFileUrl = this.UserFilesPath + sFileName ;
					break ;
				}
			}

			SendResults( iErrorNumber, sFileUrl, sFileName ) ;
		}

		#region SendResults Method

		private void SendResults( int errorNumber )
		{
			SendResults( errorNumber, "", "", "" ) ;
		}

		private void SendResults( int errorNumber, string fileUrl, string fileName )
		{
			SendResults( errorNumber, fileUrl, fileName, "" ) ;
		}

		private void SendResults( int errorNumber, string fileUrl, string fileName, string customMsg )
		{
			Response.Clear() ;

			Response.Write( "<script type=\"text/javascript\">" ) ;
			Response.Write( "window.parent.OnUploadCompleted(" + errorNumber + ",'" + fileUrl.Replace( "'", "\\'" ) + "','" + fileName.Replace( "'", "\\'" ) + "','" + customMsg.Replace( "'", "\\'" ) + "') ;" ) ;
			Response.Write( "</script>" ) ;

			Response.End() ;
		}

		#endregion
	}
}
